/*
Copyright (C) 2004-2005 Amour Hassan
                                                                                
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.
                                                                                
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
                                                                                
You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
                                                                                
*/

#include "player.h"
#include "engine/engine_game.h"

extern "C" gmThing *spw_phPerson()
{
	return new phPerson();
}

extern "C" gmThing *spw_phPlayer()
{
	return new phPlayer();
}

extern "C" int del_phPerson( gmThing *t)
{
	delete t;
	return 0;
}

extern "C" int del_phPlayer( gmThing *t)
{
	delete t;
	return 0;
}

extern "C" int gm_main( const std::string *key, GameEngine *ge,
	std::string *emsg)
{
	ge->m_thing_manager->add_to_spawn_list( "phPerson", spw_phPerson);
	ge->m_thing_manager->add_to_spawn_list( "phPlayer", spw_phPlayer);

	ge->m_thing_manager->add_to_delete_list( "phPerson", del_phPerson);
	ge->m_thing_manager->add_to_delete_list( "phPlayer", del_phPlayer);
	
	return 0;
}

phPerson::phPerson()
{
}

phPerson::~phPerson()
{
}

phPlayer::phPlayer()
{
}

phPlayer::~phPlayer()
{
}
