/*
Copyright (C) 2004-2005 Amour Hassan

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#include "main_header.h"
#include <SDL/SDL.h>
#include <iostream>
#include "engine_game.h"
#include "things/things.h"

int main()
{
	if( krn_initialize_system()) {
		SDL_Quit();
		std::cerr << "Failed to initialize system!\n";
		return -1;
	}

	{
		GameEngine ge;
		if( !(ge.engine_ok())) {
			SDL_Quit();
			return -1;
		}

		krn_create_screen( ge.mdata->m_screen, ge.mdata->m_width,
			ge.mdata->m_height, ge.mdata->m_color_depth,
			ge.mdata->m_zbuffer_depth);
		if( !ge.mdata->m_screen) {
			SDL_Quit();
			std::cerr << "Failed to create screen!\n";
			return -1;
		}

		ge.startup();
		while( true) {
			if( krn_check_events( *(ge.mdata))) break;
			if( ge.process()) break;
		}
	}

	SDL_Quit();
	return 0;
}
