/*
Copyright (C) 2004-2005 Amour Hassan
                                                                                
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.
                                                                                
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
                                                                                
You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
                                                                                
*/

#include <SDL/SDL.h>
#include "main_header.h"
#include <iostream>
#include <string>
#include "engine_game.h"

void krn_do_key_down( SDL_Event &event, MainData &mdata)
{
	// XXX: "key" stores the id number of the key pressed.
	//	Type "man SDL_KeyboardEvent" for more information.
	//	Additionaly, "man SDL_keysym" and "man SDLKey".
	const int key = event.key.keysym.sym;
	std::string tmp;
	switch( key) {
	case SDLK_BACKSPACE: tmp = "back_space"; break;
	case SDLK_TAB: tmp = "tab"; break;
	case SDLK_CLEAR: tmp = "clear"; break;
	case SDLK_RETURN: tmp = "return"; break;
	case SDLK_PAUSE: tmp = "pause"; break;
	case SDLK_ESCAPE: tmp = "esc"; break;
	case SDLK_DELETE: tmp = "delete"; break;
	case SDLK_KP0: tmp = "keypad_0"; break;
	case SDLK_KP1: tmp = "keypad_1"; break;
	case SDLK_KP2: tmp = "keypad_2"; break;
	case SDLK_KP3: tmp = "keypad_3"; break;
	case SDLK_KP4: tmp = "keypad_4"; break;
	case SDLK_KP5: tmp = "keypad_5"; break;
	case SDLK_KP6: tmp = "keypad_6"; break;
	case SDLK_KP7: tmp = "keypad_7"; break;
	case SDLK_KP8: tmp = "keypad_8"; break;
	case SDLK_KP9: tmp = "keypad_9"; break;
	case SDLK_KP_PERIOD: tmp = "keypad_period"; break;
	case SDLK_KP_DIVIDE: tmp = "keypad_divide"; break;
	case SDLK_KP_MULTIPLY: tmp = "keypad_multiply"; break;
	case SDLK_KP_MINUS: tmp = "keypad_minus"; break;
	case SDLK_KP_PLUS: tmp = "keypad_plus"; break;
	case SDLK_KP_ENTER: tmp = "keypad_enter"; break;
	case SDLK_KP_EQUALS: tmp = "keypad_equals"; break;
	case SDLK_UP: tmp = "arrow_up"; break;
	case SDLK_DOWN: tmp = "arrow_down"; break;
	case SDLK_RIGHT: tmp = "arrow_right"; break;
	case SDLK_LEFT: tmp = "arrow_left"; break;
	case SDLK_INSERT: tmp = "insert"; break;
	case SDLK_HOME: tmp = "home"; break;
	case SDLK_END: tmp = "end"; break;
	case SDLK_PAGEUP: tmp = "page_up"; break;
	case SDLK_PAGEDOWN: tmp = "page_down"; break;
	case SDLK_F1: tmp = "f1"; break;
	case SDLK_F2: tmp = "f2"; break;
	case SDLK_F3: tmp = "f3"; break;
	case SDLK_F4: tmp = "f4"; break;
	case SDLK_F5: tmp = "f5"; break;
	case SDLK_F6: tmp = "f6"; break;
	case SDLK_F7: tmp = "f7"; break;
	case SDLK_F8: tmp = "f8"; break;
	case SDLK_F9: tmp = "f9"; break;
	case SDLK_F10: tmp = "f10"; break;
	case SDLK_F11: tmp = "f11"; break;
	case SDLK_F12: tmp = "f12"; break;
	case SDLK_F13: tmp = "f13"; break;
	case SDLK_F14: tmp = "f14"; break;
	case SDLK_F15: tmp = "f15"; break;
	case SDLK_NUMLOCK: tmp = "num_lock"; break;
	case SDLK_CAPSLOCK: tmp = "caps_lock"; break;
	case SDLK_SCROLLOCK: tmp = "scroll_lock"; break;
	case SDLK_RSHIFT: tmp = "right_shift"; break;
	case SDLK_LSHIFT: tmp = "left_shift"; break;
	case SDLK_RCTRL: tmp = "right_control"; break;
	case SDLK_LCTRL: tmp = "left_control"; break;
	case SDLK_RALT: tmp = "right_alt"; break;
	case SDLK_LALT: tmp = "left_alt"; break;
	case SDLK_RMETA: tmp = "right_meta"; break;
	case SDLK_LMETA: tmp = "left_meta"; break;
	case SDLK_LSUPER: tmp = "left_super"; break;
	case SDLK_RSUPER: tmp = "right_super"; break;
	case SDLK_MODE: tmp = "mode_shift"; break;
	case SDLK_HELP: tmp = "help"; break;
	case SDLK_PRINT: tmp = "print_screen"; break;
	case SDLK_SYSREQ: tmp = "sysreq"; break;
	case SDLK_BREAK: tmp = "break"; break;
	case SDLK_MENU: tmp = "menu"; break;
	case SDLK_POWER: tmp = "power"; break;
	case SDLK_EURO: tmp = "euro"; break;
	default:
		if( key <= 127) tmp += char( key);
		else {
			std::cerr << "krn_do_key_down: key " << key
				<< " unsupported\n";
			return;
		}
		break;
	}
//	std::cerr << "down = " << key << ", " << (char)key <<
//		", " << tmp << "\n";
	mdata.ge->exec_key( tmp, "down");
}

void krn_do_key_up( SDL_Event &event, MainData &mdata)
{
	// XXX: "key" stores the id number of the key released.
	//	Type "man SDL_KeyboardEvent" for more information.
	//	Additionaly, "man SDL_keysym" and "man SDLKey".
	const int key = event.key.keysym.sym;
	std::string tmp;
	switch( key) {
	case SDLK_BACKSPACE: tmp = "back_space"; break;
	case SDLK_TAB: tmp = "tab"; break;
	case SDLK_CLEAR: tmp = "clear"; break;
	case SDLK_RETURN: tmp = "return"; break;
	case SDLK_PAUSE: tmp = "pause"; break;
	case SDLK_ESCAPE: tmp = "esc"; break;
	case SDLK_DELETE: tmp = "delete"; break;
	case SDLK_KP0: tmp = "keypad_0"; break;
	case SDLK_KP1: tmp = "keypad_1"; break;
	case SDLK_KP2: tmp = "keypad_2"; break;
	case SDLK_KP3: tmp = "keypad_3"; break;
	case SDLK_KP4: tmp = "keypad_4"; break;
	case SDLK_KP5: tmp = "keypad_5"; break;
	case SDLK_KP6: tmp = "keypad_6"; break;
	case SDLK_KP7: tmp = "keypad_7"; break;
	case SDLK_KP8: tmp = "keypad_8"; break;
	case SDLK_KP9: tmp = "keypad_9"; break;
	case SDLK_KP_PERIOD: tmp = "keypad_period"; break;
	case SDLK_KP_DIVIDE: tmp = "keypad_divide"; break;
	case SDLK_KP_MULTIPLY: tmp = "keypad_multiply"; break;
	case SDLK_KP_MINUS: tmp = "keypad_minus"; break;
	case SDLK_KP_PLUS: tmp = "keypad_plus"; break;
	case SDLK_KP_ENTER: tmp = "keypad_enter"; break;
	case SDLK_KP_EQUALS: tmp = "keypad_equals"; break;
	case SDLK_UP: tmp = "arrow_up"; break;
	case SDLK_DOWN: tmp = "arrow_down"; break;
	case SDLK_RIGHT: tmp = "arrow_right"; break;
	case SDLK_LEFT: tmp = "arrow_left"; break;
	case SDLK_INSERT: tmp = "insert"; break;
	case SDLK_HOME: tmp = "home"; break;
	case SDLK_END: tmp = "end"; break;
	case SDLK_PAGEUP: tmp = "page_up"; break;
	case SDLK_PAGEDOWN: tmp = "page_down"; break;
	case SDLK_F1: tmp = "f1"; break;
	case SDLK_F2: tmp = "f2"; break;
	case SDLK_F3: tmp = "f3"; break;
	case SDLK_F4: tmp = "f4"; break;
	case SDLK_F5: tmp = "f5"; break;
	case SDLK_F6: tmp = "f6"; break;
	case SDLK_F7: tmp = "f7"; break;
	case SDLK_F8: tmp = "f8"; break;
	case SDLK_F9: tmp = "f9"; break;
	case SDLK_F10: tmp = "f10"; break;
	case SDLK_F11: tmp = "f11"; break;
	case SDLK_F12: tmp = "f12"; break;
	case SDLK_F13: tmp = "f13"; break;
	case SDLK_F14: tmp = "f14"; break;
	case SDLK_F15: tmp = "f15"; break;
	case SDLK_NUMLOCK: tmp = "num_lock"; break;
	case SDLK_CAPSLOCK: tmp = "caps_lock"; break;
	case SDLK_SCROLLOCK: tmp = "scroll_lock"; break;
	case SDLK_RSHIFT: tmp = "right_shift"; break;
	case SDLK_LSHIFT: tmp = "left_shift"; break;
	case SDLK_RCTRL: tmp = "right_control"; break;
	case SDLK_LCTRL: tmp = "left_control"; break;
	case SDLK_RALT: tmp = "right_alt"; break;
	case SDLK_LALT: tmp = "left_alt"; break;
	case SDLK_RMETA: tmp = "right_meta"; break;
	case SDLK_LMETA: tmp = "left_meta"; break;
	case SDLK_LSUPER: tmp = "left_super"; break;
	case SDLK_RSUPER: tmp = "right_super"; break;
	case SDLK_MODE: tmp = "mode_shift"; break;
	case SDLK_HELP: tmp = "help"; break;
	case SDLK_PRINT: tmp = "print_screen"; break;
	case SDLK_SYSREQ: tmp = "sysreq"; break;
	case SDLK_BREAK: tmp = "break"; break;
	case SDLK_MENU: tmp = "menu"; break;
	case SDLK_POWER: tmp = "power"; break;
	case SDLK_EURO: tmp = "euro"; break;
	default:
		if( key <= 127) tmp += char( key);
		else {
			std::cerr << "krn_do_key_up: key " << key
				<< " unsupported\n";
			return;
		}
		break;
	}
//	std::cerr << "up = " << key << ", " << (char)key <<
//		", " << tmp << "\n";
	mdata.ge->exec_key( tmp, "up");
}

void krn_do_mouse_down( SDL_Event &event, MainData &mdata)
{
	// XXX: "event.button" holds "mouse down" information.
	//	Type "man SDL_MouseButtonEvent" for more information.
}

void krn_do_mouse_motion( SDL_Event &event, MainData &mdata)
{
	// XXX: "event.motion" holds "mouse motion" information.
	//	Type "man SDL_MouseMotionEvent" for more information.
}

void krn_do_mouse_up( SDL_Event &event, MainData &mdata)
{
	// XXX: "event.button" holds "mouse up" information.
	//	Type "man SDL_MouseButtonEvent" for more information.
}


int krn_check_events( MainData &mdata)
{
	SDL_Event event;
	while( SDL_PollEvent( &event)) {
		switch( event.type) {
		case SDL_KEYDOWN:
			krn_do_key_down( event, mdata);
			break;

		case SDL_KEYUP:
			krn_do_key_up( event, mdata);
			break;

		case SDL_MOUSEBUTTONDOWN:
			krn_do_mouse_down( event, mdata);
			break;

		case SDL_MOUSEMOTION:
			krn_do_mouse_motion( event, mdata);
			break;

		case SDL_MOUSEBUTTONUP:
			krn_do_mouse_up( event, mdata);
			break;

		case SDL_QUIT: return 1;
		}
	}
	return 0;
}
