/*
Copyright (C) 2004-2005 Amour Hassan
                                                                                
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.
                                                                                
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
                                                                                
You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
                                                                                
*/

#ifndef MAIN_HEADER_H
#define MAIN_HEADER_H

class SDL_Surface;
class GameEngine;

class MainData
{
public:
	SDL_Surface *m_screen;
	int m_width;
	int m_height;
	int m_color_depth;
	int m_zbuffer_depth;

	GameEngine *ge;

	MainData( GameEngine *p_ge) {
		m_screen = 0;
		m_width = 640;
		m_height = 480;
		m_color_depth = 24;
		m_zbuffer_depth = 16;
		ge = p_ge;
	}
};

int krn_initialize_system();
int krn_check_events( MainData &mdata);
int krn_create_screen( SDL_Surface *&screen, int width, int height,
	int color_depth, int zbuffer_depth);

#endif
